/***************************************************************************
                          u_scanner.c  -  description
                             -------------------
    begin                : Mon Aug 11 17:35:11 CET 2003
    copyright            : (C) 2003 by johanneshub
    email                : johanneshub@foni.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <error.h>
#include <unistd.h>
#include <fcntl.h>

#define FALSE   0
#define TRUE    1

int send_cmd(int, char *, int);
int read_cmd(int, char *, int);


int open_device( void )
{
  int handle;

  printf( "opening device /dev/usb/scanner0\n");

  if((handle=open("/dev/usb/scanner0", O_RDWR)) < 0) {
    perror("Unable to open scanner device");
    return(0);
  }
  return handle;
}



int read_usb( int device,int ep,char *data,int size,int timeout)
{ /*Writes out size elements from buf starting from reg*/
  int read;

#ifdef USBDEBUG
  char *tmp=data;
  int tmp_size=size;


    fprintf(stderr,"transfer type=bulk size=%d ep=%x dir=IN\n",size,ep);
#endif

  read = read_cmd(device, data, size);
  if ( read !=size ){
        printf( "problem doing read; only %d read from %d\n", (int)read, (int)size );
        return(FALSE);
      }
  else
  {
/*    fprintf(stderr,"USB read %x bytes \n",size);*/
#ifdef USBDEBUG
    while(tmp_size--) fprintf(stderr,"%02hhx ",*tmp++);
    fprintf(stderr,"\n");
#endif
    return(TRUE);
  };
};

int write_usb(int device,int ep,char *data,int size,int timeout)
{
    int err,write;
#ifdef USBDEBUG
    char *tmp=data;
    int tmp_size=size;

    fprintf(stderr,"transfer type=bulk size=%d ep=%x dir=OUT\n",size,ep);
    while(tmp_size--) fprintf(stderr,"%02hhx ",*tmp++);
    fprintf(stderr,"\n");
#endif

    write = send_cmd(device, data, size);
    if ( write != size ) {
      printf( "problem doing write %d\n",err );
      return(0);
    } else
      return(write);
}


int
send_cmd(int fp, char * cmd, int length) {

	int result;

	if((result = write(fp, cmd, length)) != length) {
#ifdef USBDEBUG
		printf ("Write warning: %d bytes requested, %d written\n",length,result);
#endif
	} else if (result < 0) {
		perror ("send_cmd failure");
		exit (1);
	}
	return (result);
}

int
read_cmd(int fp, char * response, int length) {

	return read(fp, response, length);

}
